uint64_t clock_cycles( void ) {
    typedef struct hl { uint32_t lo, hi; } hl_t;
//    hl_t hl;
    typedef union sc {
//        struct hl r;
        hl_t     r;
        uint64_t f;
    } sc_t;
    sc_t sc;
   __asm__ __volatile__ ( "rdtsc" : "=a"( sc.r.lo ), "=d"( sc.r.hi ) );
   return sc.f;
}

unsigned clock_calibrate( long rep ) {
#define NUMB 1000
   uint32_t n, m, sum = 0;
   uint64_t cf, cs;
   n = m = ( 0 >= rep ? NUMB : rep );
   while( n-- ) {
      cf  = clock_cycles();
      cs  = clock_cycles();
      sum += ( cs - cf );
   }
   return sum / m;
}

